<html>
<head>
    <style>
        body {
            background: #000;
        }

        p {
            color: #FCEFA8;
        }

        p span {
            color: #F5D000;
            font-weight: bold;
        }

        main {
            max-width: 980px;
        }

        #map,
        #results {
            display: inline-block;
            box-sizing: border-box;
            float: left;
        }

        #map {
            height: 100%;
            width: 70%;
        }

        #results {
            width: 30%;
            padding: 20px;
            padding-top: 0;
        }

        #results p:first-of-type {
            margin-top: 0;
        }

        .device-mobile-optimized #map,
        .device-mobile-optimized #results {
            width: 100%;
        }

        .device-mobile-optimized #results {
            margin-top: 20px;
        }

        #btnReset {
            display: none;
            padding: 5px 10px;
            background: #F5D000;
            color: #000000;
            border: 0;
            font-size: 14px;
            border-radius: 13.5px;
        }

        #btnReset.show {
            display: block;
        }

    </style>
</head>
<body>
    <main>
    <div id="map"></div>
    <div id="results">

        <p>Origin: <span id="originLocation"></span></p>
        <p>Destination: <span id="destinationLocation"></span></p>
        <p>Estimated distance: <span id="estimatedDistance"></span></p>
        <p>Estimated time: <span id="estimatedTime"></span></p>

        <div class="tariffA">
            <p>Monday to Saturday 07:00-23:00: <span>&pound;</span><span id="fareA"></span></p>
        </div>
        <div class="tariffB">
            <p>Monday-Sunday 23:00-07:00: <span>&pound;</span><span id="fareB"></span></p>
        </div>
        <div class="tariffC">
            <p>Sunday 07:00-23:00: <span>&pound;</span><span id="fareC"></span></p>
        </div>
        <div class="tariffChristmas">
            <p>Christmas Eve - Boxing Day & New Years Eve - 2nd January: <span>&pound;</span><span id="fareChristmas"></span></p>
        </div>

        <button onclick="reset();" id="btnReset">Reset</button>
    </div>

    </main>
    <script>
        var milesDivide = 1609;
        var distance;
        var miles;
        var multiplier;
        var estimatedDistance;
        var estimatedTime;
        var originLocation;
        var destinationLocation;

        var map;
        var geocoder;
        var points = [];
        var clickCount = 0;

        var markers = [];

        function reset() {
            console.log('test');
            clickCount = 0;
            document.getElementById('originLocation').innerHTML = "";
            document.getElementById('destinationLocation').innerHTML = "";
            document.getElementById('estimatedTime').innerHTML = "";
            document.getElementById('estimatedDistance').innerHTML = "";
            document.getElementById('fareA').innerHTML = "";
            document.getElementById('fareB').innerHTML = "";
            document.getElementById('fareC').innerHTML = "";
            document.getElementById('fareChristmas').innerHTML = "";
            deleteMarkers();
            points = [];
        }

        function setMapOnAll(map) {
          for (var i = 0; i < markers.length; i++) {
            markers[i].setMap(map);
          }
        }

        function clearMarkers() {
            setMapOnAll(null);
        }


        function deleteMarkers() {
          clearMarkers();
          markers = [];
        }

        function kmToMiles(distance, milesDivide) {
            miles = distance / milesDivide;
            multiplier = miles * 10;
            calcTariffA(multiplier);
            calcTariffB(multiplier);
            calcTariffC(multiplier);
            calcTariffChristmas(multiplier);
            document.getElementById('originLocation').innerHTML = originLocation;
            document.getElementById('destinationLocation').innerHTML = destinationLocation;
            document.getElementById('estimatedTime').innerHTML = estimatedTime;
            document.getElementById('estimatedDistance').innerHTML = estimatedDistance;
        }

        function calcTariffA(multiplier) {
            console.log(multiplier)
            var base = 3.65;
            var perTenth = .27;
            var cost = (base + (multiplier * perTenth));
            var printCost = cost.toFixed(2).toString();
            document.getElementById('fareA').innerHTML = printCost;
        }

        function calcTariffB(multiplier) {
            var base = 3.73;
            var perTenth = .39;
            var cost = (base + (multiplier * perTenth));
            var printCost = cost.toFixed(2).toString();
            document.getElementById('fareB').innerHTML = printCost;
        }

        function calcTariffC(multiplier) {
            var base = 3.16;
            var perTenth = .33;
            var cost = (base + (multiplier * perTenth));
            var printCost = cost.toFixed(2).toString();
            document.getElementById('fareC').innerHTML = printCost;
        }

        function calcTariffChristmas(multiplier) {
            var base = 6.51;
            var perTenth = .43;
            var cost = (base + (multiplier * perTenth));
            var printCost = cost.toFixed(2).toString();
            document.getElementById('fareChristmas').innerHTML = printCost;
        }

        
        function initMap() {
            var myLatlng = {lat: 49.2154052, lng: -2.160795};
            geocoder = new google.maps.Geocoder();

            map = new google.maps.Map(document.getElementById('map'), {
              center: myLatlng,
              zoom: 12
            });

            map.addListener('click', function(e) {
                if (clickCount <= 2) {
                    console.log('Under 2');
                    placeMarkerAndPanTo(e.latLng, map, clickCount);
                    clickCount++;
                    points.push(e.latLng);

                    if (clickCount == 2) {
                        document.getElementById('btnReset').classList.add('show');
                        calcDistance(points)
                    }
                }
            });
        }

        function calcDistance(points) {
            let directionsService = new google.maps.DirectionsService();
            
            const route = {
                origin: points[0],
                destination: points[1],
                travelMode: 'DRIVING'
            }
        
            directionsService.route(route,
              function(response, status) { // anonymous function to capture directions
                if (status !== 'OK') {
                  window.alert('Directions request failed due to ' + status);
                  return;
                } else {
                  var directionsData = response.routes[0].legs[0]; // Get data about the mapped route
                  console.log('RESPONSE');
                  console.log(response);
                  if (!directionsData) {
                    window.alert('Directions request failed');
                    return;
                  }
                  else {
                      distance = (directionsData.distance.value);
                      estimatedDistance = directionsData.distance.text;
                      estimatedTime = directionsData.duration.text;
                      kmToMiles(distance, milesDivide);
                  }
                }
              });
        }

        function placeMarkerAndPanTo(latLng, map, clickCount) {
            var marker = new google.maps.Marker({
                position: latLng,
                map: map
            });
            markers.push(marker);
            map.panTo(latLng);

            geocoder.geocode({'location': latLng}, function(results, status) {
              if (status === 'OK') {
                if (results[0]) {
                    console.log('geocode-clickcount');
                    console.log(clickCount);
                    if(clickCount == 0) {
                        originLocation = results[0].formatted_address;
                    } else {
                        destinationLocation = results[0].formatted_address;
                    }
                } else {
                  window.alert('No results found');
                }
              } else {
                window.alert('Geocoder failed due to: ' + status);
              }
            });

            console.log(marker.getPosition());
        }
    </script>

    <script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyD1celqHkQtVNAWYoCabmQ_gQ1F5tbktiU&callback=initMap" async defer></script>
</body>
</html>